var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import { widgetRegistry } from '../hocs/widget-registry';
import { schemaRegistry } from './schema-registry';
import { defineMetaProperty, mergeFields, buildInitialState, isEditor, } from './utils';
export function DefineSystem(_a) {
    var { name } = _a, widget = __rest(_a, ["name"]);
    return (constructor) => {
        defineMetaProperty(constructor, 'systemName', name);
        if (!isEditor()) {
            return;
        }
        const fields = mergeFields(widget.fields, Reflect.getMetadata('schema:fields', constructor));
        const getInitialState = () => buildInitialState(fields, widget.getInitialState);
        schemaRegistry.addWidget('system', name, Object.assign(Object.assign({}, widget), { view: widgetRegistry.getWidget(name), fields,
            getInitialState }));
    };
}
